#!/usr/bin/perl

use File::Copy;
use File::Basename;
use File::Spec;
use File::Path;

# the following parameters are set-up at build time


sub change_dir {
  my $dir = shift;
  print "Change dir to $dir\n";
  return chdir $dir;
}

sub cmd {
  $c = shift;
  print "$c\n";
  system("$c");
  if( $? ) {
    print "Error: $!, exiting\n";
    exit 1;
  }
}

sub cmd_silent {
  $c = shift;
  system("$c");
  if( $? ) {
    print "Error: $!, exiting\n";
    exit 1;
  }
}

sub cmd_noerr {
  $c = shift;
  print "$c\n";
  system("$c");
  if( $? ) {
    return 1;
  }
  return 0;
}

$CUR_DIR = `chdir`; chop $CUR_DIR;

# syntax windows : upgrade.pl "<SERVER_ROOT>" <ADMIN ID> <ADMIN PASSWORD> <UPGRADE_ADMIN>
# syntax windows : upgrade.pl "<SERVER_ROOT>" <UPGRADE_ADMIN>

$SERVER_ROOT    = $ARGV[0];


$UPGRADE_ADMIN  = $ARGV[3];

my @upgrade_time = localtime(time);
my $time_ext = sprintf("%d%02d%02d-%02d:%02d", 
		       $upgrade_time[5]+1900, $upgrade_time[4], $upgrade_time[3],
		       $upgrade_time[2], $upgrade_time[1]);

my $CREDS_FILE = File::Spec->catfile("$CUR_DIR", "creds");

open(CREDS, ">creds") || die "Could not create : creds, $!";
print CREDS "Admin Id: $ARGV[1]\n";
print CREDS "Admin Password: $ARGV[2]\n";
close CREDS;

my $DPS_installed = 1;

change_dir $SERVER_ROOT;

sleep(5);

# Now restart the DPS servers
opendir(SERVERDIR, "$SERVER_ROOT") || die "Could not open directory : $SERVER_ROOT, $!";
@instance_dirs = grep { /^dps-/ } readdir SERVERDIR;
if ($DPS_installed) {
    for (@instance_dirs) {
	my $start_dir = File::Spec->catfile("$SERVER_ROOT","$_");
	if( -d $start_dir) {
	    print "cd $start_dir\n";
	    chdir $start_dir;
	    my $start_dps = File::Spec->catfile(File::Spec->curdir(), "start-dps");
# not correct on windows if( -x  $start_dps) {
		print "Starting instance : $_\n";
		cmd "$start_dps";
#	    }
	}
    }
}

sleep(30);
				
# need to restart CDS (if local) when upgrading AS
print  "Please make sure that the Configuration DS is started <HIT RETURN>\n";
$key = getc() ;

if ($DPS_installed) {
    my $sync_dps = File::Spec->catfile("$SERVER_ROOT", 
					 "bin",
					 "dps",
					 "install",
					 "script",
					 "sync-dps.tcl");
				 
    my $sync_dps_cds =  File::Spec->catfile("$SERVER_ROOT", 
					    "bin",					
					    "dps",		       
					    "install", 
					    "script",			 
					    "sync-dps-cds.tcl");


    my $as_bin = File::Spec->catfile("$AS_BASEDIR",
				     "usr",
				     "sadm",
				     "mps",
				     "admin",
				     "v5.2", 
				     "bin");


    my $tcl_shell = File::Spec->catfile("$SERVER_ROOT", "bin", "tcl8.2", "tclsh ");

    $sync_dps = $tcl_shell . $sync_dps . " -syncType upgrade -cid $SERVER_ROOT -serverroot $SERVER_ROOT ";
   
      
    $res = cmd $sync_dps;
    if( $res ) {
	print "Warning, sync_dps returned with error\n";
    }
    else
    {
	$sync_dps_cds = $tcl_shell . $sync_dps_cds . " -cid $SERVER_ROOT -serverroot $SERVER_ROOT -verbose";
	
	$res = cmd $sync_dps_cds;
	if( $res ) {
	    print "Warning, sync_dps_cds returned with error\n";
	}			
#    error code ?
    }				
}    

# And start the admin server

my $start_admin = File::Spec->catfile("$SERVER_ROOT", "start-admin");

print "Starting the admin server...\n";
cmd $start_admin;


unlink "$CREDS_FILE";

print "\n\nDone\n\n";



