
#!/usr/bin/perl

use File::Copy;
use File::Basename;
use File::Spec;
use File::Path;

# the following parameters are set-up at build time


sub change_dir {
  my $dir = shift;
  print "Change dir to $dir\n";
  return chdir $dir;
}

sub cmd {
  $c = shift;
  print "$c\n";
  system("$c");
  if( $? ) {
    print "Error: $!, exiting\n";
    exit 1;
  }
}

sub cmd_silent {
  $c = shift;
  system("$c");
  if( $? ) {
    print "Error: $!, exiting\n";
    exit 1;
  }
}

sub cmd_noerr {
  $c = shift;
  print "$c\n";
  system("$c");
  if( $? ) {
    return 1;
  }
  return 0;
}

$CUR_DIR = `chdir`; chop $CUR_DIR;

# syntax windows : upgrade.pl "<SERVER_ROOT>" <ADMIN ID> <ADMIN PASSWORD> <UPGRADE_ADMIN>
# syntax windows : upgrade.pl "<SERVER_ROOT>" <UPGRADE_ADMIN>

$SERVER_ROOT    = $ARGV[0];

$UPGRADE_ADMIN  = $ARGV[3];

my $CREDS_FILE = File::Spec->catfile("$CUR_DIR", "creds");
open(CREDS, ">creds") || die "Could not create : creds, $!";
print CREDS "Admin Id: $ARGV[1]\n";
print CREDS "Admin Password: $ARGV[2]\n";
close CREDS;

my $DPS_installed = 0;

# We need first to stop all instances of the DPS server
opendir(SERVERDIR, "$SERVER_ROOT") || die "Could not open directory : $SERVER_ROOT, $!";
@instance_dirs = grep { /^dps-/ } readdir SERVERDIR;
for (@instance_dirs) {
  my $stop_dps_dir = File::Spec->catfile("$SERVER_ROOT", $_);
  if( -d $stop_dps_dir) {
      $DPS_installed =  1 ;
    change_dir $stop_dps_dir || die "Could not change dir to $stop_dps_dir";

    my $stop_dps = File::Spec->catfile(File::Spec->curdir(), "stop-dps");
#not correct on windows    if( -x $stop_dps ) {
      print "Stopping instance : $_\n";
      cmd_noerr "$stop_dps";
#    }
  }
}

if ($DPS_installed) {
    my $sync_dps = File::Spec->catfile("$SERVER_ROOT", 
					 "bin",
					 "dps",
					 "install",
					 "script",
					 "sync-dps.tcl");		 
    
    
    my $tcl_shell = File::Spec->catfile("$SERVER_ROOT", "bin", "tcl8.2", "tclsh ");

    $sync_dps = $tcl_shell . $sync_dps . " -syncType downgrade -cid $SERVER_ROOT -serverroot $SERVER_ROOT ";

    $res = cmd $sync_dps;
    if( $res ) {
	print "Warning, sync_dps returned with error\n";
    }
        			
} 

unlink "$CREDS_FILE";

print "\n\nDone\n\n";