#!/usr/bin/perl

use File::Copy;
use File::Basename;
use File::Spec;
use File::Path;


sub change_dir {
  my $dir = shift;
  print "Change dir to $dir\n";
  return chdir $dir;
}

sub cmd {
  $c = shift;
  print "$c\n";
  system("$c");
  if( $? ) {
    print "Error: $!, exiting\n";
    exit 1;
  }
}

sub cmd_silent {
  $c = shift;
  system("$c");
  if( $? ) {
    print "Error: $!, exiting\n";
    exit 1;
  }
}

sub cmd_noerr {
  $c = shift;
  print "$c\n";
  system("$c");
  if( $? ) {
    return 1;
  }
  return 0;
}

$CUR_DIR = `chdir`; chop $CUR_DIR;    


# syntax windows : upgrade.pl "<SERVER_ROOT>" <ADMIN ID> <ADMIN PASSWORD> <UPGRADE_ADMIN>
# syntax windows : upgrade.pl "<SERVER_ROOT>" <UPGRADE_ADMIN>

$SERVER_ROOT    = $ARGV[0];

$UPGRADE_ADMIN  = $ARGV[3];


my $CREDS_FILE = File::Spec->catfile("$CUR_DIR", "creds");
open(CREDS, ">creds") || die "Could not create : creds, $!";
print CREDS "Admin Id: $ARGV[1]\n";
print CREDS "Admin Password: $ARGV[2]\n";
close CREDS;

my $DPS_installed = 0;


print  "Please stop all DS instances under this server root <HIT RETURN>\n";
$key = getc() ;


# We need first to stop all instances of the DPS server
opendir(SERVERDIR, "$SERVER_ROOT") || die "Could not open directory : $SERVER_ROOT, $!";
@instance_dirs = grep { /^dps-/ } readdir SERVERDIR;
for (@instance_dirs) {
  my $stop_dps_dir = File::Spec->catfile("$SERVER_ROOT", $_);
  if( -d $stop_dps_dir) {
      $DPS_installed =  1 ;
    change_dir $stop_dps_dir || die "Could not change dir to $stop_dps_dir";

    my $stop_dps = File::Spec->catfile(File::Spec->curdir(), "stop-dps");
#not correct on windows    if( -x $stop_dps ) {
      print "Stopping instance : $_\n";
      cmd_noerr "$stop_dps";
#    }
  }
}

# And to stop the admin server (wether or not we want to upgrade the admin server)

my $stop_admin = File::Spec->catfile("$SERVER_ROOT", "stop-admin");
print "Stopping the admin server...\n";
cmd_noerr $stop_admin;

change_dir $CUR_DIR;

sleep(30);
				
unlink "$CREDS_FILE";

print "\n\nDone\n\n";



